(component
  (core module $Module
    ;; returns length of string
    (func (export "entry") (param i32 i32) (result i32)
      local.get 1
    )
    
    ;; stub allocator, returning null pointer always
    (func (export "realloc") (param i32 i32 i32 i32) (result i32)
      i32.const 0    
    )
    
    ;; memory for string
    ;; 1 page, allows to store 2**16 chars
    (memory (export "memory") 1)
  )
  
  ;; create instance of module, with no imports
  (core instance $m (instantiate $Module))
  
  ;; api declaration for entry here
  (func (export "entry") (param "str" string) (result u32)
    (canon lift
      (core func $m "entry")
      (memory $m "memory")
      (realloc (func $m "realloc"))
    )
  )
)
